// Generated by CoffeeScript 1.6.1
(function() {
  var XMLBuilder, XMLDeclaration, XMLDocType, XMLElement, XMLStringifier, _;

  _ = require('underscore');

  XMLStringifier = require('./XMLStringifier');

  XMLDeclaration = require('./XMLDeclaration');

  XMLDocType = require('./XMLDocType');

  XMLElement = require('./XMLElement');

  module.exports = XMLBuilder = (function() {

    function XMLBuilder(name, options) {
      var root;
      if (name == null) {
        throw new Error("Root element needs a name");
      }
      if (options == null) {
        options = {};
      }
      this.stringify = new XMLStringifier(options);
      if (!options.headless) {
        this.xmldec = new XMLDeclaration(this, options);
        if (options.ext != null) {
          this.doctype = new XMLDocType(this, options);
        }
      }
      root = new XMLElement(this, 'doc');
      root = root.element(name);
      root.isRoot = true;
      root.documentObject = this;
      this.rootObject = root;
    }

    XMLBuilder.prototype.root = function() {
      return this.rootObject;
    };

    XMLBuilder.prototype.end = function(options) {
      return toString(options);
    };

    XMLBuilder.prototype.toString = function(options) {
      var r;
      r = '';
      if (this.xmldec != null) {
        r += this.xmldec.toString(options);
      }
      if (this.doctype != null) {
        r += this.doctype.toString(options);
      }
      return r += this.rootObject.toString(options);
    };

    return XMLBuilder;

  })();

}).call(this);
